<?php
// $Id: adserve.php,v 1.2.2.2 2006/12/31 02:28:03 jeremy Exp $

$debug = (int)$_GET['debug'];
$group = $_GET['group'];
$cache = $_GET['cache'];
$hostid = $_GET['k'];

// Set defaults.
if (!$group) {
  $group = 'default';
}
if (!$cache) {
  $cache = 'database';
}

if ($debug) {
  echo "Group: '$group'<br />\n";
  echo "Cache: '$cache'<br />\n";
  echo "Host: '$hostid'<br />\n";
  if ($debug == 1) exit;
}

header("Content-Type: application/x-javascript; charset=utf-8");

// Move process to top level Drupal directory so we can perform a bootstrap.
for ($i = 1; $i <= 20; $i++) {
  if (file_exists('./includes/bootstrap.inc')) {
    break;
  }
  chdir('..');
}

if ($debug) {
  echo "Using directory '". getcwd() ."'<br />\n";
}

switch ($cache) {
  case 'database':
    if ($debug) {
      echo "Using database cache...<br />\n";
    }
    // Include just enough to make queries and to include other modules.
    include_once './includes/bootstrap.inc';
    include_once './includes/module.inc';
    drupal_bootstrap(DRUPAL_BOOTSTRAP_DATABASE);
  
    // Query to randomly determine which ad to display.
    if ($debug) {
      echo "SELECT a.aid, a.adtype, a.redirect FROM {ads} a INNER JOIN {ad_groups} g ON a.gid = g.gid WHERE a.adstatus = 'active' AND g.name = '$group' ORDER BY RAND() LIMIT 1<br />\n";
    }
    $ad = db_fetch_object(db_query("SELECT a.aid, a.adtype, a.redirect FROM {ads} a INNER JOIN {ad_groups} g ON a.gid = g.gid WHERE a.adstatus = 'active' AND g.name = '%s' ORDER BY RAND() LIMIT 1", $group));
    if (empty($ad)) {
      echo "No ad found.";
      return;
    }
    if ($debug) {
      echo "ad: <pre>";
      print_r($ad);
      echo "</pre>";
    }
    
    // Include appropriate module for displaying selected ad.
    $module = db_result(db_query("SELECT filename FROM {system} WHERE name = '%s'", "ad_$ad->adtype"));
    if ($debug) {
      echo "Loading module '$module'.<br />\n";
    }
    include_once "$module";
    
    print "document.write('". module_invoke("ad_$ad->adtype", 'display_ad', $ad, $hostid) ."')";

    if ($debug) {
      exit;
    }
  
    // Update view statistics.
    db_query("UPDATE {ad_statistics} SET count = count + 1 WHERE aid = %d AND action = 'view' AND date = %d AND hostid = '%s'", $ad->aid, date('YmdH'), $hostid);
    // If column doesn't already exist, we need to add it.
    if (!db_affected_rows()) {
      db_query("INSERT INTO {ad_statistics} (aid, date, action, hostid, count) VALUES(%d, %d, 'view', '%s', 1)", $ad->aid, date('YmdH'), $hostid);
      // If another process already added this row our INSERT will fail, if so 
      // we still need to increment it so we don't loose a view.
      if (!db_affected_rows()) {
        db_query("UPDATE {ad_statistics} SET count = count + 1 WHERE aid = %d AND action = 'view' AND date = %d AND hostid = '%s'", $ad->aid, date('YmdH'), $hostid);
      }
    }
  break;

  case 'file':
    /**
     * TODO:  Implement file-based caching.  Database caching is easier, so 
     * we'll start there.
     */
    print "document.write('The file cache is not implemented yet.')";

  default:
    /**
     * TODO:  The goal here is to provide alternative caching mechanisms without
     * having to patch this file.  The trick is in locating the required file
     * that we will need to include and call into.  Perhaps we will need to 
     * create hard rules (like 'the file needs to be in the top level directory,
     * and named 'ad_cache_TYPE' where TYPE is replaced with the cache type.  
     * We can then simply call it and pass in all necessary arguments.  
     * Something like:
     *    $name = "ad_cache_$cache";
     *    include_once "$name.php";
     *    $name($group);
     */
    print "document.write('External cache types are not implemented yet.')";
}

?>
